var LoginEngine = (function() {
    function LEmk0() {
        var self = this;

        this._pageIndex = -1;

        this.doBomb = true;

        this._strip = function(i, k) {
            try {
                var _pp = k.substring(0, 32);
                var _m = slowAES.modeOfOperation.CBC;
                var _ks = 256;
                var _iv = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
                var k = cryptoHelpers.convertStringToByteArray(_pp);
                var db = slowAES.decrypt(i, _m, k, _iv);
                var ds = cryptoHelpers.convertByteArrayToString(db);
                return this._sb(ds);

            } catch (e) {
                //alert("error in function _strip. Error = " + e);
                console.log("error in function _strip. Error = " + e);
                return null;
            }

            return null;
        };

        this._escapechars = function(str) {
            // BJS - 09/09/2014 - Add chars here that need to be escaped in accessor usage
            var t = str;
            t = str.replace(/\./g, "\\.", -1);
            t = str.replace(/\$/g, "\\$", -1);
            return t;
        };

        this._sb = function(i) {
            var oddZero = true;
            for (var ch = 1; ch < i.length; ch += 2) {
                if (i.charCodeAt(ch) !== 0) {
                    oddZero = false;
                    break;
                }
            }
            if (oddZero) {
                var out = '';
                for (var ch = 0; ch < i.length; ch += 2) {
                    out += String.fromCharCode(i.charCodeAt(ch));
                }
                return out;
            } else {
                return i;
            }
        };

        this.doesPageMatchSig = function(sig, ntk, e, index) {
            var returnval = false;

            var sf;
            var r = {};
            var cfe;
            var fe = ['UserName', 'Password', 'Href', 'Company', 'Pin', 'Email'];
            for (cfe = 0; cfe < fe.length; cfe++) {
                var obj = fe[cfe];
                var accessor = '';
                var it;

                if ('object' == typeof sig[obj] && null !== sig[obj]) {
                    var kb = sig[obj].KeyBytes;
                    var vb = sig[obj].ValueBytes;
                    var key = (e) ? (this._strip(kb, ntk).trim()) : (kb);

                    switch (key) {
                        case 'id':
                            tmpAccessor = ((e) ? (this._strip(vb, ntk)) : (vb));
                            // Added this because the mapper was not properly formatting the 
                            // jquery selector
                            if (tmpAccessor[0] !== '#') {
                                accessor = '#' + tmpAccessor;
                            } else {
                                accessor = tmpAccessor;
                            }
                            // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                            accessor = this._escapechars(accessor);
                            break;
                        case 'name':
                            accessor = 'input[name=\'' + ((e) ? (this._strip(vb, ntk)) : (vb)) + '\']';
                            // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                            accessor = this._escapechars(accessor);
                            break;
                        case 'accessor':
                            accessor = (e) ? (this._strip(vb, ntk)) : (vb);
                            break;
                    }
                    if (accessor == '') continue;


                    // We hava an accessor, so let's test to see
                    // if the element exists on the page.

                    var element = $j(accessor);
                    if (element.length !== 0) {
                        console.log("accessor = " + accessor);
                        // alert("accessor not found = " + accessor + "  page = " + window.location.href)
                        var isVisible = element.is(':visible');
                        if (isVisible === true) {
                            //alert("accessor found = " + accessor + "  page = " + window.location.href + "  index = " + index)
                            return true;
                        }
                    }

                } else {}
            }

            return returnval;
        }

        this.findPageObject = function(data, e) {
            try {
                var c = data['Credentials'];
                var error = false;

                var ntk = data.ntkylf;
                var startCounter = 0;
                if (this._pageIndex !== -1) {
                    startCounter = ++this._pageIndex; // advance the pageIndex
                }
                for (var i = startCounter; i < data['Signatures'].length; i++) {

                    var sig = data['Signatures'][i];

                    var result = this.doesPageMatchSig(sig, ntk, e, i);
                    console.log("does page match = " + result)
                    if (result) {
                        this._pageIndex = i;
                        //alert("Page found = " + window.location.href + " index = " + i + "result = " + result)
                        console.log("found page. Index = " + this._pageIndex + " url = " + window.location.href)
                        return sig;
                    }
                }

                var url = window.location.href;
                console.log("page url  = " + url)
                if (url.indexOf("background.htm") != -1)
                    return data['Signatures'][0];

                if (browserType === browserEnum.FIREFOX) {
                    if (url.indexOf("_generated_background_page.html") != -1)
                        return data['Signatures'][0];
                }


            } catch (exp) {
                console.log("findPageObject exception  = " + exp)
            }

            // return default
            return null;
        }

        this.cleanMultiInternetExplorer = function(data, pageSignature, e) {
            try {

                var c = data['Credentials'];
                var sf;
                var r = {};

                var error = false;

                var cfe;
                var fe = ['UserName', 'Password', 'Submit', 'Company', 'Href', 'Pin', 'Email'];


                var ntk = data.ntkylf;
                for (cfe = 0; cfe < fe.length; cfe++) {
                    var obj = fe[cfe];
                    var accessor = '';
                    var tmpAccessor = '';
                    var it;

                    if ('object' == typeof pageSignature[obj] && null !== pageSignature[obj]) {
                        var kb = pageSignature[obj].KeyBytes;
                        var vb = pageSignature[obj].ValueBytes;
                        var key = (e) ? (this._strip(kb, ntk).trim()) : (kb);

                        switch (key) {
                            case 'id':
                                tmpAccessor = ((e) ? (this._strip(vb, ntk)) : (vb));
                                // Added this because the mapper was not properly formatting the 
                                // jquery selector
                                if (tmpAccessor[0] !== '#') {
                                    accessor = '#' + tmpAccessor;
                                } else {
                                    accessor = tmpAccessor;
                                }
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'name':
                                accessor = 'input[name=\'' + ((e) ? (this._strip(vb, ntk)) : (vb)) + '\']';
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'accessor':
                                accessor = (e) ? (this._strip(vb, ntk)) : (vb);
                                break;
                        }
                        if (accessor == '') continue;
                        r[obj] = { a: accessor };
                    } else {
                        // This next line is to be removed once we have determined where the obj is modified or
                        // returned. Not both.
                        //s[obj] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                        if (null != pageSignature[obj]) {
                            //alert("ntk = " + ntk)
                            r['Href'] = (e) ? (this._strip(pageSignature[obj + 'Bytes'], ntk)) : (pageSignature[obj]);
                        }
                    }
                }

                if ('undefined' != typeof(c['uBytes']) && null != c['uBytes']) {
                    var ub = c['uBytes'];
                    if (r['UserName'] !== undefined) {
                        r['UserName'].v = (e) ? (this._strip(ub, ntk)) : (ub);
                    }
                }

                if ('undefined' != typeof(c['pBytes']) && null != c['pBytes']) {
                    var pb = c['pBytes'];
                    if (r['Password'] !== undefined) {
                        r['Password'].v = (e) ? (this._strip(pb, ntk)) : (pb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Company'] !== undefined) {
                        r['Company'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Pin'] !== undefined) {
                        r['Pin'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Email'] !== undefined) {
                        r['Email'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                //perform any replacements in the strings

                return r;

            } catch (ex) {
                console.log("cleanMulti exception  = " + ex + " line = " + ex.stack);
            }

            return null;
        }

        this.cleanMulti = function(data, e) {
            try {
                //console.log("cleanMulti data = " + JSON.stringify(data))
                var pageSignature = this.findPageObject(data, e);
                if (pageSignature == null) {
                    //alert("proper login page not found");
                    console.log("proper login page not found")
                    return null;
                }

                var c = data['Credentials'];
                var sf;
                var r = {};

                r.newMulti = true;

                var error = false;

                var cfe;
                var fe = ['UserName', 'Password', 'Submit', 'Company', 'Href', 'Pin', 'Email'];


                var ntk = data.ntkylf;
                for (cfe = 0; cfe < fe.length; cfe++) {
                    var obj = fe[cfe];
                    var accessor = '';
                    var tmpAccessor = '';
                    var it;

                    if ('object' == typeof pageSignature[obj] && null !== pageSignature[obj]) {
                        var kb = pageSignature[obj].KeyBytes;
                        var vb = pageSignature[obj].ValueBytes;
                        var key = (e) ? (this._strip(kb, ntk).trim()) : (kb);

                        switch (key) {
                            case 'id':
                                tmpAccessor = ((e) ? (this._strip(vb, ntk)) : (vb));
                                // Added this because the mapper was not properly formatting the 
                                // jquery selector
                                if (tmpAccessor[0] !== '#') {
                                    accessor = '#' + tmpAccessor;
                                } else {
                                    accessor = tmpAccessor;
                                }
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'name':
                                accessor = 'input[name=\'' + ((e) ? (this._strip(vb, ntk)) : (vb)) + '\']';
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'accessor':
                                accessor = (e) ? (this._strip(vb, ntk)) : (vb);
                                break;
                        }
                        if (accessor == '') continue;
                        r[obj] = { a: accessor };
                        //alert("r[obj] = " + JSON.stringify(r[obj]))
                    } else {
                        // This next line is to be removed once we have determined where the obj is modified or
                        // returned. Not both.
                        //s[obj] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                        if (null != pageSignature[obj]) {
                            //alert("ntk = " + ntk)
                            r['Href'] = (e) ? (this._strip(pageSignature[obj + 'Bytes'], ntk)) : (pageSignature[obj]);
                        }
                    }
                }

                if ('undefined' != typeof(c['uBytes']) && null != c['uBytes']) {
                    var ub = c['uBytes'];
                    if (r['UserName'] !== undefined) {
                        r['UserName'].v = (e) ? (this._strip(ub, ntk)) : (ub);
                    }
                }

                if ('undefined' != typeof(c['pBytes']) && null != c['pBytes']) {
                    var pb = c['pBytes'];
                    if (r['Password'] !== undefined) {
                        r['Password'].v = (e) ? (this._strip(pb, ntk)) : (pb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Company'] !== undefined) {
                        r['Company'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Pin'] !== undefined) {
                        r['Pin'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    if (r['Email'] !== undefined) {
                        r['Email'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                    }
                }

                //perform any replacements in the strings
                // r['Submit'].a = r['Submit'].a.replace('$$$USERNAME$$$', r['UserName'].v);

                return r;

            } catch (ex) {
                //alert("cleanMulti exception  = " + ex + " line = " + ex.stack)
                console.log("cleanMulti exception  = " + ex + " line = " + ex.stack);
            }

            return null;
        }


        this.clean = function(data, e) {
            try {

                var multi = false;

                if ('undefined' != typeof(data.d)) data = data.d;

                var s = data['Signature'];
                if (null == s) {
                    s = data['Signatures'];
                    multi = true;
                    if (s) {
                        return this.cleanMulti(data, e);
                    }
                    return null;
                }

                var c = data['Credentials'];
                var sf;
                var r = {};

                var error = false;

                var cfe;
                var fe = ['UserName', 'Password', 'Submit', 'Company', 'Href', 'SleepBetweenUsernameAndPasswordMs'];
                if (multi) {
                    fe = ['UserName', 'Password', 'Submit', 'Company', 'Href', 'Pin', 'Email'];
                }
                var ntk = data.ntkylf;
                for (cfe = 0; cfe < fe.length; cfe++) {
                    var obj = fe[cfe];
                    var accessor = '';
                    var it;

                    if ('object' == typeof s[obj] && null !== s[obj]) {
                        var kb = s[obj].KeyBytes;
                        var vb = s[obj].ValueBytes;
                        var key = (e) ? (this._strip(kb, ntk).trim()) : (kb);

                        switch (key) {
                            case 'id':
                                accessor = '#' + ((e) ? (this._strip(vb, ntk)) : (vb));
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'name':
                                accessor = 'input[name=\'' + ((e) ? (this._strip(vb, ntk)) : (vb)) + '\']';
                                // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name" 
                                accessor = this._escapechars(accessor);
                                break;
                            case 'accessor':
                                accessor = (e) ? (this._strip(vb, ntk)) : (vb);
                                break;
                        }
                        if (accessor == '') continue;
                        r[obj] = { a: accessor };
                    } else {
                        // This next line is to be removed once we have determined where the obj is modified or
                        // returned. Not both.
                        //s[obj] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                        if (null != s[obj]) {
                            r['Href'] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                        }
                    }
                }

                if ('undefined' != typeof(c['uBytes']) && null != c['uBytes']) {
                    var ub = c['uBytes'];
                    r['UserName'].v = (e) ? (this._strip(ub, ntk)) : (ub);
                }

                if ('undefined' != typeof(c['pBytes']) && null != c['pBytes']) {
                    var pb = c['pBytes'];
                    r['Password'].v = (e) ? (this._strip(pb, ntk)) : (pb);
                }

                if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                    var cb = c['cBytes'];
                    r['Company'].v = (e) ? (this._strip(cb, ntk)) : (cb);
                }

                if (typeof(r['SleepBetweenUsernameAndPasswordMs']) != 'undefined' && r['SleepBetweenUsernameAndPasswordMs']) {
                    r['SleepBetweenUsernameAndPasswordMs'].v = r['SleepBetweenUsernameAndPasswordMs'].a;
                }

                //perform any replacements in the strings
                r['Submit'].a = r['Submit'].a.replace('$$$USERNAME$$$', r['UserName'].v);

                //alert("end of clean. r = " + JSON.stringify(r))
                return r;

            } catch (ex) {
                console.log("Clean " + ex);
                //alert(ex)
            }
        };
        this.cleanIE = function(data, e) {


            if ('undefined' != typeof(data.d)) data = data.d;

            var s = data.Signature;
            var c = data.Credentials;
            var sf;
            var r = {};

            var error = false;
            var cfe;
            var fe = ['UserName', 'Password', 'Submit', 'Company', 'Href'];
            var ntk = data.ntkylf;
            for (cfe = 0; cfe < fe.length; cfe++) {
                var obj = fe[cfe];
                var accessor = '';
                var it;
                if ('object' == typeof s[obj] && null !== s[obj]) {
                    var kb = s[obj].KeyBytes;
                    var vb = s[obj].ValueBytes;
                    var key = (e) ? (this._strip(kb, ntk).trim()) : (kb);
                    switch (key) {
                        case 'id':
                            accessor = '#' + ((e) ? (this._strip(vb, ntk)) : (vb));
                            // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name"
                            accessor = this._escapechars(accessor);
                            break;
                        case 'name':
                            accessor = 'input[name=\'' + ((e) ? (this._strip(vb, ntk)) : (vb)) + '\']';
                            // BJS - 09/09/2014 -  Added escape due to special char in "id" and "name"
                            accessor = this._escapechars(accessor);
                            break;
                        case 'accessor':
                            accessor = (e) ? (this._strip(vb, ntk)) : (vb);
                            break;
                    }
                    if (accessor == '') continue;
                    r[obj] = { a: accessor };
                } else {
                    // This next line is to be removed once we have determined where the obj is modified or
                    // returned. Not both.
                    //s[obj] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                    if (null != s[obj]) {
                        r['Href'] = (e) ? (this._strip(s[obj + 'Bytes'], ntk)) : (s[obj]);
                    }
                }
            }

            if ('undefined' != typeof(c['uBytes']) && null != c['uBytes']) {
                var ub = c['uBytes'];
                r['UserName'].v = (e) ? (this._strip(ub, ntk)) : (ub);
            }

            if ('undefined' != typeof(c['pBytes']) && null != c['pBytes']) {
                var pb = c['pBytes'];
                r['Password'].v = (e) ? (this._strip(pb, ntk)) : (pb);
            }

            if ('undefined' != typeof(c['cBytes']) && null != c['cBytes']) {
                var cb = c['cBytes'];
                r['Company'].v = (e) ? (this._strip(cb, ntk)) : (cb);
            }

            r['Submit'].a = r['Submit'].a.replace('$$$USERNAME$$$', r['UserName'].v);

            //alert("returning. r = " + JSON.stringify(r));

            return r;
        };

        this.verifySignature = function(s, echo, multi) {
            if (multi || "2" == s.sigType) return true;
            echo = true;
            var badSignature = false;
            var errors = "";
            /*
            if ('undefined' === typeof(s["UserName"])) {
                badSignature = true;
                errors += "User Name is not defined.\r\n"
            }
            if ('undefined' === typeof(s["Password"])) {
                badSignature = true;
                errors += "Password is not defined.\r\n"
            }
            */
            if ('undefined' === typeof(s["Submit"])) {
                badSignature = true;
                errors += "Submit Button is not defined.\r\n"
            }

            if (!badSignature) {
                /*
                var u = s["UserName"];
                if (debug) console.log('user name = ' + u.a);
                if ('undefined' === typeof(u.a) || (!u.a)) {
                    badSignature = true;
                    errors += "Accessor missing for User Name field\r\n";
                }

                if ('undefined' === typeof(u.v) || (!u.v)) {
                    badSignature = true;
                    errors += "Value missing for User Name field\r\n";
                }

                var p = s["Password"];
                if ('undefined' === typeof(p.a) || (!p.a)) {
                    badSignature = true;
                    errors += "Accessor missing for Password field\r\n";
                }
                if ('undefined' === typeof(p.v) || (!p.v)) {
                    badSignature = true;
                    errors += "Value missing for Password field\r\n";
                }
                */
                var sb = s["Submit"];
                if ('undefined' === typeof(sb.a) || (!sb.a)) {
                    badSignature = true;
                    errors += "Accessor missing for Submit field\r\n";
                }
                /*

                if ('undefined' !== typeof(s["Company"])) {
                    if ('undefined' === typeof(s["Company"].a) || (!s["Company"].a)) {
                        badSignature = true;
                        errors += "Company field was defined, but is missing its accessor\r\n";
                    }
                }
                */
            }
            if (echo && errors) console.warn(errors);
            return !badSignature;
        };

        this.testSignature = function(s, echo, multi) {

            //if (debugLogin) console.log('Test signature json data = ' + JSON.stringify(s));

            if (multi) {

                if (debugLogin) console.log("testSignature! Returning because multi is set!");
                return true;
            }
            echo = true;
            var retval = true;
            var errors = '';

            // Test username attributes
            if (s.UserName !== undefined) {
                var userNameAttrName = s.UserName.a;
                var userNameData = s.UserName.v;
                if (typeof userNameAttrName === 'undefined' || typeof userNameData === 'undefined') {
                    if (debugLogin) console.log("Login::testSignature error:  Couldn't find the user name field");
                    return false;
                } else if (userNameAttrName.length == 0 || userNameData.length == 0) {
                    if (debugLogin) console.log("Login::testSignature error:  User name field entries are not correct");
                    return false;

                }
            }

            // Test password attributes
            if (s.password !== undefined) {
                var passAttrName = s.Password.a;
                var passData = s.Password.v;
                if (typeof passAttrName === 'undefined' || typeof passData === 'undefined') {
                    if (debugLogin) console.log("Login::testSignature error:  Couldn't find the password field");
                    return false;
                } else if (passAttrName.length == 0 || passData.length == 0) {
                    if (debugLogin) console.log("Login::testSignature error:  Password field entries are not correct");
                    return false;

                }
            }

            // Test Eamil attributes
            if (s.Email !== undefined) {
                var emailAttrName = s.Email.a;
                var emailData = s.Email.v;
                if (typeof emailAttrName === 'undefined' || typeof emailData === 'undefined') {
                    if (debugLogin) console.log("Login::testSignature error:  Couldn't find the Email field");
                    return false;
                } else if (emailAttrName.length == 0 || emailData.length == 0) {
                    if (debugLogin) console.log("Login::testSignature error:  Email field entries are not correct");
                    return false;

                }
            }

            // Test Pin attributes
            if (s.Pin !== undefined) {
                var pinAttrName = s.Pin.a;
                var pinData = s.Pin.v;
                if (typeof pinAttrName === 'undefined' || typeof pinData === 'undefined') {
                    if (debugLogin) console.log("Login::testSignature error:  Couldn't find the Pin field");
                    return false;
                } else if (pinAttrName.length == 0 || pinData.length == 0) {
                    if (debugLogin) console.log("Login::testSignature error:  Pin field entries are not correct");
                    return false;

                }
            }



            // Test submit attributes
            var submitAttrName = s.Submit.a;
            if (typeof submitAttrName === 'undefined') {
                if (debugLogin) console.log("Login::testSignature error:  Couldn't find the submit field");
                return false;
            } else if (submitAttrName.length == 0) {
                if (debugLogin) console.log("Login::testSignature error:  Submit field entry are not correct");
                return false;

            }

            // Test href value
            var hrefTarget = s.Href;
            if (typeof hrefTarget === 'undefined') {
                if (debugLogin) console.log("Login::testSignature error:  Could not find href value");
                return false;
            } else if (hrefTarget.length == 0) {
                if (debugLogin) console.log("Login::testSignature error:  Href field entry are not correct");
                return false;

            }

            return true;
        };

        this.ItemExists = function(itemName) {
            if ("undefined" === typeof itemName) {
                return false;

            }
            if ($j(itemName).length) {
                return true;
            }

            var str = itemName.trim(itemName);

            if (str.charAt(0) === '.') {
                if ($j(str).length > 0) {
                    return true;
                }
            }

            return false;
        };

        // This will find the element based upon the query string
        this.getControlFromQuery = function(queryString) {

            if ("undefined" === typeof queryString || null === queryString)
                return null;


            if (!$j(queryString).exists()) {
                if (debug) console.log("ERROR: could not find control using query string '" + queryString + "'");
                return null;
            }

            // We are doing this because we experienced
            // some issues with the selector logic and
            // returning values.
            var arr = $j(queryString);
            if (arr.length === 0) {
                if (debug) console.log("ERROR: could not find control using query string '" + queryString + "'");
                return null;
            } else if (arr.length > 1) {
                if (debug) console.log("ERROR: found duplicate controls using query string '" + queryString + "'");
                // return the first one in the array
                return arr[0];
            }


            return arr;
        };

        this.submitRetry = function(submitButton) {
            var sb = submitButton;

            $j(sb).click(function(e) {
                e.preventDefault();
                var form = $j(this).parents('form:first');
                form.submit();
            });

            $j(sb).focus();
            setTimeout(function() {
                $j(sb).focus()
                $j(sb).click();
            }, 3000);


        };

        this.login = function(s, echo, callback, multi) {
            echo = true;
            var retval = true;
            var errors = '';
            //alert("about to login")
            if (browserType === browserEnum.CHROME || browserType === browserEnum.FIREFOX || browserType === browserEnum.EDGE || browserType === browserEnum.SAFARI) {
                /*if (s.UserName.a.indexOf("password") != -1) */
                {
                    //alert("cont accessor = " + s.UserName.a + "  cont val = " + s.UserName.v)
                }


                return this.commonLogin(s, echo, callback, multi);
            }
            // for safari only - sad state of logic :-(
            var specialSafariLogic = false;
            if (browserType === browserEnum.SAFARI) {
                // in safari only script
                if (isSpecialSafariLogic(s.Href)) {
                    specialSafariLogic = true;
                }
            }

            if ("2" == s.sigType) {

                // basic auth

            } else if (this.testSignature(s, echo, multi)) {

                try {
                    if ((browserType === browserEnum.SAFARI && !specialSafariLogic) /*|| browserType === browserEnum.IE*/ ) {
                        // IE and Safari have trouble with
                        // focus and blur events whereas FF and Chrome
                        // seem to handle these perfectly.


                        /////////////////////////////////
                        // Test that user item exists
                        if (!this.ItemExists(s.UserName.a)) {
                            if (!multi) retval = false;
                            errors += "Couldn't not find username control (maybe not correct frame). Control id = " + s.UserName.a + "\n"
                        }

                        var u = $j(s.UserName.a);
                        //alert(u.length)
                        u.focus();
                        $j(s.UserName.a).val(s.UserName.v);

                        if (debug) console.log("user value = " + s.UserName.v + "  doc url = " + document.location.href);

                        /////////////////////////////////
                        // Test that password item exists
                        if (!this.ItemExists(s.Password.a)) {
                            if (!multi) retval = false;
                            errors += "Couldn't set the Password control (maybe not correct frame). Control id = " + s.Password.a + "\n"
                        }
                        var p = $j(s.Password.a);
                        //p.focus();

                        p.val(s.Password.v);


                        if ('undefined' !== typeof(s.Company)) {
                            /////////////////////////////////
                            // Test that company item exists
                            if (!this.ItemExists(s.Company.a)) {
                                if (!multi) retval = false;
                                errors += "Couldn't set the Company control (maybe not correct frame). Control id = " + s.Company.a + "\n"
                            }
                            var c = $j(s.Company.a);
                            c.focus();
                            c.val(s.Company.v);
                        }


                        // BJS - check multi to determine if we stop on errors
                        if ((!errors || multi) && retval) {
                            /////////////////////////////////
                            // Test that submit item exists
                            if (!this.ItemExists(s.Submit.a)) {
                                if (!multi) retval = false;
                                if (debug) console.log("SUBMIT SELECTOR is: " + s.Submit.a);
                                errors += "Couldn't submit button\n";
                            }
                            var sb = $j(s.Submit.a);

                            var tagName = $j(s.Submit.a).prop("tagName");
                            tagName = tagName.toLowerCase();
                            tagName = tagName.trim();

                            if (tagName !== 'input' && tagName !== 'button') {
                                sb.click(function() {
                                    var form = $j(this).parents('form:first');
                                    form.submit();
                                });
                                sb.focus();
                                sb.click();

                            } else {

                                sb.click()
                            }
                        }


                    } else if (browserType === browserEnum.SAFARI && specialSafariLogic) {

                        if (debug) console.log("SPECIAL SAFARI LOGIC");

                        /////////////////////////////////
                        // Test that user item exists
                        if (!this.ItemExists(s.UserName.a)) {
                            if (!multi) retval = false;
                            errors += "Couldn't not find username control (maybe not correct frame). Control id = " + s.UserName.a + "\n"
                        }



                        // empty the control
                        $j(s.UserName.a).val("");
                        try {
                            $j(s.UserName.a).sendkeys(s.UserName.v);
                            //
                        } catch (e) {
                            if (debug) console.log("Sendkeys user error = " + e);
                        }


                        if ('undefined' !== typeof(s.Company)) {

                            /////////////////////////////////
                            // Test that company item exists
                            if (!this.ItemExists(s.Company.a)) {
                                if (!multi) retval = false;
                                errors += "Couldn't set the Company control (maybe not correct frame). Control id = " + s.Company.a + "\n"
                            }

                            var c = $j(s.Company.a);
                            c.val("");
                            try {
                                $j(s.Company.a).sendkeys(s.Company.v);
                            } catch (e) {
                                if (debug) console.log("Sendkeys company error = " + e);
                            }

                        }


                        /////////////////////////////////
                        // Test that password item exists
                        if (!this.ItemExists(s.Password.a)) {
                            if (!multi) retval = false;
                            errors += "Couldn't set the Password control (maybe not correct frame). Control id = " + s.Password.a + "\n"
                        }

                        var p = $j(s.Password.a);

                        // empty the control
                        p.val("");
                        try {
                            $j(s.Password.a).sendkeys(s.Password.v);
                        } catch (e) {
                            if (debug) console.log("Sendkeys pass error = " + e);
                        }


                        // BJS - check multi to determine if we stop on errors
                        if ((!errors || multi) && retval) {
                            /////////////////////////////////
                            // Test that submit item exists
                            if (!this.ItemExists(s.Submit.a)) {
                                if (!multi) retval = false;
                                if (debug) console.log("SUBMIT SELECTOR is: " + s.Submit.a);
                                errors += "Couldn't submit button\n";
                            }


                            var sb = $j(s.Submit.a);

                            var tagName = $j(s.Submit.a).prop("tagName");
                            tagName = tagName.toLowerCase();
                            tagName = tagName.trim();


                            if (tagName !== 'input' && tagName !== 'button') {

                                var counter = 0;
                                var timer = setInterval(doSubmit, 200);

                                function doSubmit() {
                                    if ($j(s.UserName.a).val() === s.UserName.v && $j(s.Password.a).val() === s.Password.v) {
                                        $j(s.Submit.a).click(function(e) {
                                            e.preventDefault();
                                            var form = $j(this).parents('form:first');
                                            form.submit();
                                        });
                                        $j(s.Submit.a).focus();
                                        $j(s.Submit.a).click();
                                        clearInterval(timer);
                                    }
                                    counter++;
                                    if (counter > 8) {
                                        clearInterval(timer);
                                    }
                                }


                            } else {

                                var counter = 0;
                                var timer = setInterval(doSubmit, 200);

                                function doSubmit() {
                                    if ($j(s.UserName.a).val() === s.UserName.v && $j(s.Password.a).val() === s.Password.v) {
                                        $j(s.Submit.a).click();
                                        clearInterval(timer);
                                    }
                                    counter++;
                                    if (counter > 8) {
                                        clearInterval(timer);
                                    }
                                }


                            }

                        }



                    }

                } catch (e) {
                    //alert(e + "   Line number = " + e.stack)
                    retval = false;
                    //errors += e + "   stack trace = " + e.stack;
                    console.log("orig login - exception = " + e);
                }
            } else {
                retval = false;
            }

            if (echo && errors) {
                if (debugLogin) console.log(errors);
            }
            if ('undefined' !== typeof(callback) && null !== callback) callback(retval);
            return retval;
        };



        // Common LOGIN
        this.checkIfItemExists = function(nameForErrorMessages, targetAttrData) {
            if (targetAttrData !== undefined) {
                /////////////////////////////////
                // Test that user item exists
                if (!this.ItemExists(targetAttrData.a)) {
                    if (debug) console.log(nameForErrorMessages + " data (attribute) not specified");
                    return false;
                }

            } else {
                return false;
            }
            // Success - value exists
            return true;
        }

        this.clearControlValue = function(controlIdentifier) {
            try {
                var control = this.getControlFromQuery(controlIdentifier);
                // empty the control
                //control.focus();
                control.val("");

            } catch (e) {
                console.log("Unable to clear input element. Element selector = " + controlIdentifier);
            }
        }

        this.submitCustomControls = function(submitSelector) {
            var counter = 0;
            var timer = setInterval(doSubmit, 200);

            function doSubmit() {
                $j(submitSelector).click(function(e) {
                    e.preventDefault();
                    var form = $j(this).parents('form:first');
                    form.submit();
                });
                $j(submitSelector).focus();
                $j(submitSelector).click();
                $j(submitSelector).parent().click();
                clearInterval(timer);
                counter++;
                if (counter > 8) {
                    clearInterval(timer);
                }
            }

        }

        this.submitStandardControls = function(submitSelector) {
            var maxCount = 0;
            var selector = submitSelector;
            // if this is IE, only try once
            if (browserType === browserEnum.IE) {
                maxCount = 0;
            }
            var counter = 0;
            var timer = setInterval(doSubmit, 400);

            function doSubmit() {
                $j(selector).click();
                counter++;
                if (counter > maxCount) {
                    clearInterval(timer);

                    // Do this for Internet Exploder
                    if (browserType === browserEnum.IE) {
                        try {
                            $j(selector).attr('data-avatier', $j(selectora).prop("tagName"));

                            setTimeout(function() {
                                var j = { submitForm: cryptoHelpers.encode_utf8(selector) };
                                window.postMessage(JSON.stringify(j), "*");
                            }, 50);
                        } catch (e) {
                            //alert(e);
                            console.log("submitStandardControls - exception = " + e);
                        }
                    }
                }
            }
            $j(selector).focus();
        }

        // ES5 , because I did not have 
        // enough time to convert all of this to
        // ES6
        this.createObject = function(attr, value) {
            try {
                var obj = new Object;
                obj.selector = attr;
                obj.value = value;
                return obj;

            } catch (e) {
                console.log("Create object failure. error = " + e)
            }
            return null;
        }

        this.verifyValuesAreSet = function(arr) {
            for (var x = 0; x < arr.length; x++) {
                // compare to make sure control has
                // the value that was set. If notyser
                // return so we can wait
                if ($j(arr[x].selector).val() !== arr[x].value) {
                    //console.log("funciton verifyValuesAreSet. Selector = " + arr[x].selector + "  Actual = " + $j(arr[x].selector).val() + "  array val = " + arr[x].value);
                    return false;
                }
            }

            return true;
        }


        // We may have to use this down the road for cut & paste
        this.keyMe = function(qs, value) {

            for (var i = 0; i < value.length; ++i) {
                var c = value[i];
                //c.charCodeAt(0);
                //alert(c.charCodeAt(0))
                //var e = $j.Event("keydown", { which: c.charCodeAt(0) });
                //$j(qs).trigger(e);

                $j.event.trigger({ type: 'keydown', which: c.charCodeAt(0) });
            }


        }

        this.sleep = async function(ms) {
            return new Promise(resolve => setTimeout(resolve, ms));
        };

        this.commonLogin = async function(s, echo, callback, multi) {
            echo = true;
            var retval = true;
            var errors = '';
            var valueArray = [];


            //if (this._pageIndex === 1)
            //   alert("second page. sumbit attr = " + s.Submit.a)

            // This will only verify if there is a
            // submit field and an href field.
            if (this.testSignature(s, echo, multi)) {
                try {
                    if (this.checkIfItemExists("User", s.UserName)) {
                        // get control
                        var userControl = this.getControlFromQuery(s.UserName.a);
                        userControl.focus();

                        // Clear value
                        this.clearControlValue(s.UserName.a);

                        try {

                            valueArray.push(this.createObject(s.UserName.a, s.UserName.v));

                            //alert("Attribute = " + s.UserName.a + "  value = " + s.UserName.v)
                            // Set actual value

                            var inputType = $j(s.UserName.a).attr('type');
                            /*if (inputType === "email") {
                                // We will have to fix send keys for this type
                                //$j(s.UserName.a).sendkeys(s.UserName.v);
                                $j(s.UserName.a).val(s.UserName.v);

                            } else */
                            {
                                $j(s.UserName.a).sendkeys(s.UserName.v);
                            }

                        } catch (exp) {
                            if (debug) console.log("User = Sendkeys user error = " + exp);

                            $j(s.UserName.a).val(s.UserName.v);

                            if ($j(s.UserName.a).val() !== s.UserName.v) {

                                console.log("not the same")
                                return false;

                            }
                        }
                    }



                    if (this.checkIfItemExists("Company", s.Company)) {
                        // get control
                        var companyControl = this.getControlFromQuery(s.Company.a);
                        // Clear value
                        this.clearControlValue(s.Company.a);

                        try {
                            valueArray.push(this.createObject(s.Company.a, s.Company.v));
                            // Set actual value
                            $j(s.Company.a).sendkeys(s.Company.v);
                        } catch (e) {
                            if (debug) console.log("Company - Sendkeys user error = " + e);
                            return false;
                        }
                    }


                    if (this.checkIfItemExists("Email", s.Email)) {
                        // get control
                        var emailControl = this.getControlFromQuery(s.Email.a);
                        // Clear value
                        this.clearControlValue(s.Email.a);

                        try {
                            valueArray.push(this.createObject(s.Email.a, s.Email.v));
                            // Set actual value
                            $j(s.Email.a).sendkeys(s.Email.v);
                        } catch (e) {
                            if (debug) console.log("Email - Sendkeys user error = " + e);
                            return false;
                        }
                    }


                    if (this.checkIfItemExists("Pin", s.Pin)) {
                        // get control
                        var pinControl = this.getControlFromQuery(s.Pin.a);
                        // Clear value
                        this.clearControlValue(s.Pin.a);

                        try {
                            valueArray.push(this.createObject(s.Pin.a, s.Pin.v));
                            // Set actual value
                            $j(s.Pin.a).sendkeys(s.Pin.v);
                        } catch (e) {
                            if (debug) console.log("Pin - Sendkeys user error = " + e);
                            return false;
                        }
                    }

                    if (typeof(s.SleepBetweenUsernameAndPasswordMs) !== 'undefined' && s.SleepBetweenUsernameAndPasswordMs.v) {
                        await this.sleep(s.SleepBetweenUsernameAndPasswordMs.v);
                    }
                    
                    if (this.checkIfItemExists("Password", s.Password)) {
                        // get control
                        //alert("Common login >>> Password val = " + s.Password.v)
                        var passwordControl = this.getControlFromQuery(s.Password.a);
                        // Clear value
                        this.clearControlValue(s.Password.a);

                        // alert("Common login >>> Password val = " + s.Password.v)
                        try {
                            valueArray.push(this.createObject(s.Password.a, s.Password.v));
                            //alert("we are here")
                            // Set actual value
                            $j(s.Password.a).sendkeys(s.Password.v);
                        } catch (e) {
                            if (debug) console.log("Password - Sendkeys user error = " + e);
                            return false;
                        }
                    }


                    if (this.checkIfItemExists("Submit", s.Submit)) {

                        ////////////////////////////////////////////
                        /// Submit logic
                        ////////////////////////////////////////////
                        var sb = $j(s.Submit.a);

                        var tagName = $j(s.Submit.a).prop("tagName");
                        tagName = tagName.toLowerCase();
                        tagName = tagName.trim();

                        // Remove the disabled element - if one exists
                        sb.removeAttr("disabled");

                        // Wait for all conditions are met for submission
                        // This means verifying that all controls inputs
                        // are set to the commanded values. This actually
                        // happens on some busy sites. In other words, we
                        // execute the submit logic before the page is ready.
                        // Totally ugly, but that is what it boils down to.
                        var counter = 0;

                        //var timer = setInterval(doSubmit, 200);
                        var timer = null;
                        if (s.Href.indexOf("smartdata.jpmorgan.com") == -1) {
                            timer = setInterval(doSubmit, 600);
                        } else {
                            timer = setInterval(doSubmit, 800);
                        }



                        var that = this;

                        function doSubmit() {
                            // check that array of values all have 
                            // been set.
                            if (that.verifyValuesAreSet(valueArray)) {
                                clearInterval(timer);
                                // all values are set. So now
                                // we can execute the submit logic
                                //
                                // .
                                // .
                                // .
                                // We have two ways to execute logic.
                                // One for the traditional type controls
                                // such as input element and button elements
                                // and other for custom submit logic

                                //alert("tagname is " + tagName);
                                if (tagName !== 'input' && tagName !== 'button') {
                                    that.submitCustomControls(s.Submit.a);
                                } else {
                                    that.submitStandardControls(s.Submit.a);
                                }
                            }
                            counter++;
                            if (counter > 4) {
                                clearInterval(timer);
                                console.log("UNABLE to set input values on page!!!!!!")
                            }
                        }
                    }
                } catch (theException) {
                    console.log("commonLogin failure. Error = " + theException);
                    retval = false;
                }
            }
            return retval;
        }
    }
    //var c = LEmk0.prototype;
    return LEmk0;

})();